tigase.db

## Class UserRepositoryMDImpl

- java.lang.Object
- - tigase.db.UserRepositoryMDImpl

- All Implemented Interfaces:
    Repository, UserRepository

      public class UserRepositoryMDImpl
      extends Object
      implements UserRepository

  Created: Mar 27, 2010 6:43:02 PM
  Version:
    $Rev$
  Author:
    Artur Hefczyc

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface tigase.db.Repository

      `Repository.Meta`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `UserRepositoryMDImpl()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addDataList(BareJID user, String subnode, String key, String[] list)` `addDataList` method adds mode entries to existing data list associated with given key in repository under given node path.
    `void` | `addRepo(String domain, UserRepository repo)` Method description
    `void` | `addUser(BareJID user)` This `addUser` method allows to add new user to repository.
    `String` | `getData(BareJID user, String key)` `getData` method returns a value associated with given key for user repository in default subnode.
    `String` | `getData(BareJID user, String subnode, String key)` `getData` method returns a value associated with given key for user repository in given subnode.
    `String` | `getData(BareJID user, String subnode, String key, String def)` `getData` method returns a value associated with given key for user repository in given subnode.
    `String[]` | `getDataList(BareJID user, String subnode, String key)` `getDataList` method returns array of values associated with given key or `null` if given key does not exist for given user ID in given node path.
    `String[]` | `getKeys(BareJID user)` `getKeys` method returns list of all keys stored in default user repository node.
    `String[]` | `getKeys(BareJID user, String subnode)` `getKeys` method returns list of all keys stored in given subnode in user repository.
    `UserRepository` | `getRepo(String domain)` Method description
    `String` | `getResourceUri()` Returns a DB connection string or DB connection URI.
    `String[]` | `getSubnodes(BareJID user)` `getSubnodes` method returns list of all root nodes for given user.
    `String[]` | `getSubnodes(BareJID user, String subnode)` `getSubnodes` method returns list of all direct subnodes from given node.
    `List<BareJID>` | `getUsers()` This method is only used by the data conversion tools.
    `long` | `getUsersCount()` This method is only used by the server statistics component to report number of registered users.
    `long` | `getUsersCount(String domain)` This method is only used by the server statistics component to report number of registered users for given domain.
    `long` | `getUserUID(BareJID user)` Returns a user unique ID number within the given repository.
    `void` | `initRepository(String resource_uri, Map<String,String> params)` The method is called to initialize the data repository.
    `void` | `removeData(BareJID user, String key)` `removeData` method removes pair (key, value) from user repository in default repository node.
    `void` | `removeData(BareJID user, String subnode, String key)` `removeData` method removes pair (key, value) from user repository in given subnode.
    `UserRepository` | `removeRepo(String domain)` Method description
    `void` | `removeSubnode(BareJID user, String subnode)` `removeSubnode` method removes given subnode with all subnodes in this node and all data stored in this node and in all subnodes.
    `void` | `removeUser(BareJID user)` This `removeUser` method allows to remove user and all his data from user repository.
    `void` | `setData(BareJID user, String key, String value)` This `setData` method sets data value for given user ID associated with given key in default repository node.
    `void` | `setData(BareJID user, String subnode, String key, String value)` `setData` method sets data value for given user ID in repository under given node path and associates it with given key.
    `void` | `setDataList(BareJID user, String subnode, String key, String[] list)` `setDataList` method sets list of values for given user associated given key in repository under given node path.
    `void` | `setDefault(UserRepository repo)` Method description
    `boolean` | `userExists(BareJID user)` Method `userExists` checks whether the user (or repository top node) exists in the database.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### UserRepositoryMDImpl

          public UserRepositoryMDImpl()

  - ### Method Detail

    - #### addDataList

          public void addDataList(BareJID user,
                                  String subnode,
                                  String key,
                                  String[] list)
                           throws UserNotFoundException,
                                  TigaseDBException

      Description copied from interface: `UserRepository`
      `addDataList` method adds mode entries to existing data list associated with given key in repository under given node path. This method is very similar to `setDataList(...)` except it doesn't remove existing data.
      Specified by:
        `addDataList` in interface `UserRepository`
      Parameters:
        `user` - a `BareJID` value of user ID for which data must be stored. User ID consists of user name and domain name.
        `subnode` - a `String` value is a node path where data is stored. Node path has the same form as directory path on file system:

            /root/subnode1/subnode2

        .
        `key` - a `String` with which the specified values list is to be associated.
        `list` - a `String[]` is an array of values to be associated with the specified key.
      Throws:
        `UserNotFoundException` - if user id hasn't been found in repository.
        `TigaseDBException` - if database backend error occurs.

    - #### addRepo

          public void addRepo(String domain,
                              UserRepository repo)

      Method description
      Parameters:
        `domain` -
        `repo` -

    - #### addUser

          public void addUser(BareJID user)
                       throws UserExistsException,
                              TigaseDBException

      Description copied from interface: `UserRepository`
      This `addUser` method allows to add new user to repository. It must throw en exception `UserExistsException` if such user already exists because user must be unique within user repository data base.
      As one XMPP server can support many virtual internet domains it is required that `user` id consists of user name and domain address: username@domain.address.net for example.
      Specified by:
        `addUser` in interface `UserRepository`
      Parameters:
        `user` - a `BareJID` value of user id consisting of user name and domain address.
      Throws:
        `UserExistsException` - if user with the same id already exists.
        `TigaseDBException` - if database backend error occurs.

    - #### getData

          public String getData(BareJID user,
                                String subnode,
                                String key,
                                String def)
                         throws UserNotFoundException,
                                TigaseDBException

      Description copied from interface: `UserRepository`
      `getData` method returns a value associated with given key for user repository in given subnode. If key is not found in repository given default value is returned.
      Specified by:
        `getData` in interface `UserRepository`
      Parameters:
        `user` - a `BareJID` value of user ID for which data must be stored. User ID consists of user name and domain name.
        `subnode` - a `String` value is a node path where data is stored. Node path has the same form as directory path on file system:

            /root/subnode1/subnode2

        .
        `key` - a `String` with which the needed value is associated.
        `def` - a `String` value which is returned in case if data for specified key does not exixist in repository.
      Returns:
        a `String` value
      Throws:
        `UserNotFoundException` - if user id hasn't been found in repository.
        `TigaseDBException` - if database backend error occurs.

    - #### getData

          public String getData(BareJID user,
                                String subnode,
                                String key)
                         throws UserNotFoundException,
                                TigaseDBException

      Description copied from interface: `UserRepository`
      `getData` method returns a value associated with given key for user repository in given subnode. If key is not found in repository `null` value is returned.
      Specified by:
        `getData` in interface `UserRepository`
      Parameters:
        `user` - a `BareJID` value of user ID for which data must be stored. User ID consists of user name and domain name.
        `subnode` - a `String` value is a node path where data is stored. Node path has the same form as directory path on file system:

            /root/subnode1/subnode2

        .
        `key` - a `String` with which the needed value is associated.
      Returns:
        a `String` value
      Throws:
        `UserNotFoundException` - if user id hasn't been found in repository.
        `TigaseDBException` - if database backend error occurs.

    - #### getData

          public String getData(BareJID user,
                                String key)
                         throws UserNotFoundException,
                                TigaseDBException

      Description copied from interface: `UserRepository`
      `getData` method returns a value associated with given key for user repository in default subnode. If key is not found in repository `null` value is returned.
      Specified by:
        `getData` in interface `UserRepository`
      Parameters:
        `user` - a `BareJID` value of user ID for which data must be stored. User ID consists of user name and domain name.
        `key` - a `String` with which the needed value is associated.
      Returns:
        a `String` value
      Throws:
        `UserNotFoundException` - if user id hasn't been found in repository.
        `TigaseDBException` - if database backend error occurs.

    - #### getDataList

          public String[] getDataList(BareJID user,
                                      String subnode,
                                      String key)
                               throws UserNotFoundException,
                                      TigaseDBException

      Description copied from interface: `UserRepository`
      `getDataList` method returns array of values associated with given key or `null` if given key does not exist for given user ID in given node path.
      Specified by:
        `getDataList` in interface `UserRepository`
      Parameters:
        `user` - a `BareJID` value of user ID for which data must be stored. User ID consists of user name and domain name.
        `subnode` - a `String` value is a node path where data is stored. Node path has the same form as directory path on file system:

            /root/subnode1/subnode2

        .
        `key` - a `String` with which the needed values list is associated.
      Returns:
        a `String[]` value
      Throws:
        `UserNotFoundException` - if user id hasn't been found in repository.
        `TigaseDBException` - if database backend error occurs.

    - #### getKeys

          public String[] getKeys(BareJID user,
                                  String subnode)
                           throws UserNotFoundException,
                                  TigaseDBException

      Description copied from interface: `UserRepository`
      `getKeys` method returns list of all keys stored in given subnode in user repository. There is a value (or list of values) associated with each key. It is up to user (developer) to know what key keeps one value and what key keeps list of values.
      Specified by:
        `getKeys` in interface `UserRepository`
      Parameters:
        `user` - a `BareJID` value of user ID for which data must be stored. User ID consists of user name and domain name.
        `subnode` - a `String` value is a node path where data is stored. Node path has the same form as directory path on file system:

            /root/subnode1/subnode2

        .
      Returns:
        a `String[]` value
      Throws:
        `UserNotFoundException` - if user id hasn't been found in repository.
        `TigaseDBException` - if database backend error occurs.

    - #### getKeys

          public String[] getKeys(BareJID user)
                           throws UserNotFoundException,
                                  TigaseDBException

      Description copied from interface: `UserRepository`
      `getKeys` method returns list of all keys stored in default user repository node. There is some a value (or list of values) associated with each key. It is up to user (developer) to know what key keeps one value and what key keeps list of values.
      Specified by:
        `getKeys` in interface `UserRepository`
      Parameters:
        `user` - a `BareJID` value of user ID for which data must be stored or retrieved. User ID consists of user name and domain name.
      Returns:
        a `String[]` value
      Throws:
        `UserNotFoundException` - if user id hasn't been found in repository.
        `TigaseDBException` - if database backend error occurs.

    - #### getRepo

          public UserRepository getRepo(String domain)

      Method description
      Parameters:
        `domain` -

    - #### getResourceUri

          public String getResourceUri()

      Description copied from interface: `UserRepository`
      Returns a DB connection string or DB connection URI.
      Specified by:
        `getResourceUri` in interface `UserRepository`
      Returns:
        a `String` value representing database connection string.

    - #### getSubnodes

          public String[] getSubnodes(BareJID user,
                                      String subnode)
                               throws UserNotFoundException,
                                      TigaseDBException

      Description copied from interface: `UserRepository`
      `getSubnodes` method returns list of all direct subnodes from given node.
      Specified by:
        `getSubnodes` in interface `UserRepository`
      Parameters:
        `user` - a `BareJID` value of user ID for which data must be stored. User ID consists of user name and domain name.
        `subnode` - a `String` value is a node path where data is stored. Node path has the same form as directory path on file system:

            /root/subnode1/subnode2

        .
      Returns:
        a `String[]` value is an array of all direct subnodes.
      Throws:
        `UserNotFoundException` - if user id hasn't been found in repository.
        `TigaseDBException` - if database backend error occurs.

    - #### getSubnodes

          public String[] getSubnodes(BareJID user)
                               throws UserNotFoundException,
                                      TigaseDBException

      Description copied from interface: `UserRepository`
      `getSubnodes` method returns list of all root nodes for given user.
      Specified by:
        `getSubnodes` in interface `UserRepository`
      Parameters:
        `user` - a `BareJID` value of user ID for which data must be stored. User ID consists of user name and domain name.
      Returns:
        a `String[]` value is an array of all root nodes for given user.
      Throws:
        `UserNotFoundException` - if user id hasn't been found in repository.
        `TigaseDBException` - if database backend error occurs.

    - #### getUserUID

          public long getUserUID(BareJID user)
                          throws TigaseDBException

      Description copied from interface: `UserRepository`
      Returns a user unique ID number within the given repository. Please note it is also possible that the ID number is unique only for the user domain. The ID is a positive number if the user exists and negative if the user was not found in the repository.
      Specified by:
        `getUserUID` in interface `UserRepository`
      Parameters:
        `user` - a `BareJID` value of user ID for which data must be stored or retrieved. User ID consists of user name and domain name.
      Returns:
        a user inique ID number within the repository or domain. The ID is a positive number if the user exists and negative if the user was not found in the repository.
      Throws:
        `TigaseDBException` - if there is a problem with accessing user repository.

    - #### getUsers

          public List<BareJID> getUsers()
                                 throws TigaseDBException

      Description copied from interface: `UserRepository`
      This method is only used by the data conversion tools. They attempt to copy whole user repositories from one to another database. Databases might not be compatible but as long as the API is implemented and they support adding user the user database can be copied to a different data source.
      Specified by:
        `getUsers` in interface `UserRepository`
      Returns:
        returns a collection of all user IDs (Jabber IDs) stored in the user repository.
      Throws:
        `TigaseDBException`

    - #### getUsersCount

          public long getUsersCount()

      Description copied from interface: `UserRepository`
      This method is only used by the server statistics component to report number of registered users.
      Specified by:
        `getUsersCount` in interface `UserRepository`
      Returns:
        a `long` number of registered users in the repository.

    - #### getUsersCount

          public long getUsersCount(String domain)

      Description copied from interface: `UserRepository`
      This method is only used by the server statistics component to report number of registered users for given domain.
      Specified by:
        `getUsersCount` in interface `UserRepository`
      Returns:
        a `long` number of registered users in the repository.

    - #### initRepository

          public void initRepository(String resource_uri,
                                     Map<String,String> params)
                              throws DBInitException

      Description copied from interface: `Repository`
      The method is called to initialize the data repository. Depending on the implementation all the initialization parameters can be passed either via `resource_uri` parameter as the database connection string or via `params` map if the required repository parameters are more complex or both.
      Specified by:
        `initRepository` in interface `Repository`
      Parameters:
        `resource_uri` - value in most cases representing the database connection string.
        `params` - is a `Map` with repository properties necessary to initialize and perform all the functions. The initialization parameters are implementation dependent.
      Throws:
        `DBInitException` - if there was an error during repository initialization. Some implementations, though, perform so called lazy initialization so even though there is a problem with the underlying repository it may not be signaled through this method call.

    - #### removeData

          public void removeData(BareJID user,
                                 String subnode,
                                 String key)
                          throws UserNotFoundException,
                                 TigaseDBException

      Description copied from interface: `UserRepository`
      `removeData` method removes pair (key, value) from user repository in given subnode. If the key exists in user repository there is always a value associated with this key - even empty `String`. If key does not exist the `null` value is returned from repository backend or given default value.
      Specified by:
        `removeData` in interface `UserRepository`
      Parameters:
        `user` - a `BareJID` value of user ID for which data must be stored. User ID consists of user name and domain name.
        `subnode` - a `String` value is a node path where data is stored. Node path has the same form as directory path on file system:

            /root/subnode1/subnode2

        .
        `key` - a `String` for which the value is to be removed.
      Throws:
        `UserNotFoundException` - if user id hasn't been found in repository.
        `TigaseDBException` - if database backend error occurs.

    - #### removeData

          public void removeData(BareJID user,
                                 String key)
                          throws UserNotFoundException,
                                 TigaseDBException

      Description copied from interface: `UserRepository`
      `removeData` method removes pair (key, value) from user repository in default repository node. If the key exists in user repository there is always a value associated with this key - even empty `String`. If key does not exist the `null` value is returned from repository backend or given default value.
      Specified by:
        `removeData` in interface `UserRepository`
      Parameters:
        `user` - a `BareJID` value of user ID for which data must be stored. User ID consists of user name and domain name.
        `key` - a `String` for which the value is to be removed.
      Throws:
        `UserNotFoundException` - if user id hasn't been found in repository.
        `TigaseDBException` - if database backend error occurs.

    - #### removeRepo

          public UserRepository removeRepo(String domain)

      Method description
      Parameters:
        `domain` -

    - #### removeSubnode

          public void removeSubnode(BareJID user,
                                    String subnode)
                             throws UserNotFoundException,
                                    TigaseDBException

      Description copied from interface: `UserRepository`
      `removeSubnode` method removes given subnode with all subnodes in this node and all data stored in this node and in all subnodes. Effectively it removes entire repository tree starting from given node.
      Specified by:
        `removeSubnode` in interface `UserRepository`
      Parameters:
        `user` - a `BareJID` value of user ID for which data must be stored. User ID consists of user name and domain name.
        `subnode` - a `String` value is a node path to subnode which has to be removed. Node path has the same form as directory path on file system:

            /root/subnode1/subnode2

        .
      Throws:
        `UserNotFoundException` - if user id hasn't been found in repository.
        `TigaseDBException` - if database backend error occurs.

    - #### removeUser

          public void removeUser(BareJID user)
                          throws UserNotFoundException,
                                 TigaseDBException

      Description copied from interface: `UserRepository`
      This `removeUser` method allows to remove user and all his data from user repository. If given user id does not exist `UserNotFoundException` must be thrown. As one XMPP server can support many virtual internet domains it is required that `user` id consists of user name and domain address: username@domain.address.net for example.
      Specified by:
        `removeUser` in interface `UserRepository`
      Parameters:
        `user` - a `BareJID` value of user id consisting of user name and domain address.
      Throws:
        `UserNotFoundException` - if user id hasn't been found in repository.
        `TigaseDBException` - if database backend error occurs.

    - #### setData

          public void setData(BareJID user,
                              String subnode,
                              String key,
                              String value)
                       throws UserNotFoundException,
                              TigaseDBException

      Description copied from interface: `UserRepository`
      `setData` method sets data value for given user ID in repository under given node path and associates it with given key. If there already exists value for given key in given node, old value is replaced with new value. No warning or exception is thrown in case if methods overwrites old value.
      Specified by:
        `setData` in interface `UserRepository`
      Parameters:
        `user` - a `BareJID` value of user ID for which data must be stored. User ID consists of user name and domain name.
        `subnode` - a `String` value is a node path where data is stored. Node path has the same form as directory path on file system:

            /root/subnode1/subnode2

        .
        `key` - a `String` with which the specified value is to be associated.
        `value` - a `String` value to be associated with the specified key.
      Throws:
        `UserNotFoundException` - if user id hasn't been found in repository.
        `TigaseDBException` - if database backend error occurs.

    - #### setData

          public void setData(BareJID user,
                              String key,
                              String value)
                       throws UserNotFoundException,
                              TigaseDBException

      Description copied from interface: `UserRepository`
      This `setData` method sets data value for given user ID associated with given key in default repository node. Default node is dependent on implementation and usually it is root user node. If there already exists value for given key in given node, old value is replaced with new value. No warning or exception is thrown in case if methods overwrites old value.
      Specified by:
        `setData` in interface `UserRepository`
      Parameters:
        `user` - a `BareJID` value of user ID for which data must be stored. User ID consists of user name and domain name.
        `key` - a `String` with which the specified value is to be associated.
        `value` - a `String` value to be associated with the specified key.
      Throws:
        `UserNotFoundException` - if user id hasn't been found in repository.
        `TigaseDBException` - if database backend error occurs.

    - #### setDataList

          public void setDataList(BareJID user,
                                  String subnode,
                                  String key,
                                  String[] list)
                           throws UserNotFoundException,
                                  TigaseDBException

      Description copied from interface: `UserRepository`
      `setDataList` method sets list of values for given user associated given key in repository under given node path. If there already exist values for given key in given node, all old values are replaced with new values. No warning or exception is thrown in case if methods overwrites old value.
      Specified by:
        `setDataList` in interface `UserRepository`
      Parameters:
        `user` - a `BareJID` value of user ID for which data must be stored. User ID consists of user name and domain name.
        `subnode` - a `String` value is a node path where data is stored. Node path has the same form as directory path on file system:

            /root/subnode1/subnode2

        .
        `key` - a `String` with which the specified values list is to be associated.
        `list` - a `String[]` is an array of values to be associated with the specified key.
      Throws:
        `UserNotFoundException` - if user id hasn't been found in repository.
        `TigaseDBException` - if database backend error occurs.

    - #### setDefault

          public void setDefault(UserRepository repo)

      Method description
      Parameters:
        `repo` -

    - #### userExists

          public boolean userExists(BareJID user)

      Description copied from interface: `UserRepository`
      Method `userExists` checks whether the user (or repository top node) exists in the database. The method doesn't throw any exception nor it creates the user in case it is missing. It just checks whether the user is already in the database. Please don't overuse this method. All other methods throw `UserNotFoundException` exception in case the user is missing for which you executed the method. The exception is thrown unless `userAutoCreate` property is set to true. In such case the exception is never thrown and the methods are executed for given parameters prior to creating user entry if it is missing. Therefore this method should be used only to check whether the account exists without creating it.
      Specified by:
        `userExists` in interface `UserRepository`
      Parameters:
        `user` - a `BareJID` value
      Returns:
        a `boolean` value

Copyright © 2018 "Tigase, Inc.". All rights reserved.